﻿/// @file config.h
///
/// config.h
///
#ifndef _CONFIG_H_
#define _CONFIG_H_

#include "common.h"
#include <wx/wx.h>

class Config
{
private:
	wxString ini_file;

	wxString mFilePath;
	bool     mMemoryCash;
	wxString mServerHost;
	wxString mServerPort;
	int      mPrintDelay;

public:
	Config();
	~Config();
	void SetFileName(const wxString &file);
	void Load(const wxString &file);
	void Load();
	void Save();

	// property
	void SetFilePath(const wxString &val) { mFilePath = val; }
	wxString &GetFilePath() { return mFilePath; }
	void SetMemoryCash(bool val) { mMemoryCash = val; }
	bool GetMemoryCash() { return mMemoryCash; }
	void SetServerHost(const wxString &val) { mServerHost = val; }
	wxString &GetServerHost() { return mServerHost; }
	void SetServerPort(const wxString &val) { mServerPort = val; }
	wxString &GetServerPort() { return mServerPort; }
	void SetPrintDelay(int val) { mPrintDelay = val; }
	int GetPrintDelay() { return mPrintDelay; }
};

extern Config gConfig;

#endif /* _CONFIG_H_ */
