﻿/// @file mp_model.cpp
///
/// @brief MPPRINTER 機種依存クラス
///
/// @date 2011.09.02 Create
///
/// @author Copyright (c) 2011, Sasaji. All rights reserved.
///
#include "mp_model.h"
#include "mp_printer.h"
#include <wx/filename.h>
#include <wx/wfstream.h>

// 初期化
void MP_MODEL::ClearSetting()
{
	param.line_feed_height = def_lf_height;
	param.paper_feed_height = 0.0;
	param.feed = 0;
}

// 現在のパラメータを保存
void MP_MODEL::PushSetting()
{
	param_st = param;
}

// 保存したパラメータを取り出す
void MP_MODEL::PopSetting()
{
	param = param_st;

	param.feed = 0;
}


// 印字フォントの読み込み
bool MP_MODEL::read_font(const wxString &file_name, wxByte *font_data, size_t font_data_size)
{
	wxFileName font_path(mpri->GetDataPath(), file_name);

	wxFileInputStream stream(font_path.GetFullPath());
	if (!stream.IsOk()) {
		return false;
	}
	stream.Read((void *)font_data, font_data_size);
	return true;
}
