﻿/// @file server_setting.h
///
/// @brief MPPRINTER サーバーダイアログ制御
///
/// @date 2013.11.27 Create
///
/// @author Copyright (c) 2013, Sasaji. All rights reserved.
///
#ifndef _SERVER_SETTING_H_
#define _SERVER_SETTING_H_

#include "common.h"
#include <wx/wx.h>
#include <wx/dialog.h>
#include <wx/spinctrl.h>
#include <wx/cmndata.h>

class ServerBox : public wxDialog
{
private:
	wxSpinCtrl *spinDelay;
	
	int mDelay;

	void init_dialog();
	void term_dialog();

public:
	ServerBox(wxWindow* parent, wxWindowID id);

	enum {
		IDC_SPIN_DELAY = 1,
	};

	// function
	int ShowModal();

	// event handler
	void OnButton(wxCommandEvent& event);

	// properties
	void SetDelay(int val) { mDelay = val; }
	int GetDelay() { return mDelay; }

	DECLARE_EVENT_TABLE()
};

#endif /* _SERVER_SETTING_H_ */
